%% Test the admm on an realistic image
addpath('CMG')
%% Test script for general graph



img=imresize(imread('TVexact/lena.bmp'),0.1);
figure(1)
imshow(img);

img1=double(img)/255+0.1*randn(size(img));
figure(2)
imshow(img1);


[ht,wt]=size(img1(:,:,1));
n=ht*wt;
m=(n*4-2*(ht+wt))/2;
edges1=zeros(m,1);
edges2=zeros(m,1);

%% Construct 3D image and a noisy copy

depth = 10;
sigma = 0.1;

img_3d = zeros(ht,wt,depth);
img_3d_noisy = zeros(ht,wt,depth);
for i=1:depth
    img_3d(:,:,i) = double(img(:,:,ceil(i/(depth/3))))/255;
    img_3d_noisy(:,:,i) = img_3d(:,:,i)+0.1*randn(ht,wt);
end

%% Visualize it

%implay(img_3d_noisy)


%% Now let's denoise it

lambda = 0.05;
rho = lambda;
sz=[ht,wt,depth];
k=2;
tic
[x1, history1] = gtf_admm_grid( img_3d_noisy(:),sz,k,lambda, lambda);
time_elapsed1=toc

tic
[x2, history2] = gtf_admm_grid_v1( img_3d_noisy(:),sz,k,lambda, lambda);
time_elapsed2=toc

img_3d_denoised1 = reshape(x1,sz);
img_3d_denoised2 = reshape(x2,sz);

%%
norm(img_3d_denoised1(:)- img_3d(:))
norm(img_3d_denoised2(:)- img_3d(:))

%%
results1 = cat(2,img_3d,img_3d_noisy);
results2 = cat(2,img_3d_denoised1,img_3d_denoised2);
results = cat(1,results1,results2);
implay(results)


%%
figure(4)
hold off
semilogy(history1','r-','linewidth',2)
hold on
semilogy(history2','b-','linewidth',2)
legend('ADMM primal', 'ADMM dual','ADMM primal v1', 'ADMM dual v1')