function Delta = get_Delta_grid(sz,method,k)
    % Get the genlasso operator of interest specified by 'method'
    % currently supporting only 2-dim and 3-dim
    % generalization to d-dimen is trivial.
    
    if strcmp(method,'tf2d')
        n1=sz(1);
        n2=sz(2);

%         if k==0
%             D = @(theta) diff(theta);
%         elseif k==1
%             D = @(theta) diff(diff(theta));
%         elseif k==2
%             D= @(theta) diff(diff(diff(theta)));
%         end
        D1dx = speye(n1);
        D1dy = speye(n2);
        for i=1:k+1
            D1dx = diff(D1dx);
            D1dy = diff(D1dy);
        end

        Delta = [kron(speye(n2),D1dx); kron(D1dy,speye(n1))];
    elseif strcmp(method,'tf3d')
        n1=sz(1);
        n2=sz(2);
        n3=sz(3);
        D1dx = diff(speye(n1),k+1);
        D1dy = diff(speye(n2),k+1);
        D1dz = diff(speye(n3),k+1);
        
        Delta = [kron(speye(n3),kron(speye(n2),D1dx)); 
            kron(speye(n3),kron(D1dy,speye(n1)));
        kron(D1dz,kron(speye(n2),speye(n1)))];
        
    elseif strcmp(method,'gtf2d')
        n1=sz(1);
        n2=sz(2);

        D1dx = diff(speye(n1));
        D1dy = diff(speye(n2));
        D1 = [kron(speye(n2),D1dx); kron(D1dy,speye(n1))];

        Delta=construct_O(D1,k);
    elseif strcmp(method,'gtf3d')
        n1=sz(1);
        n2=sz(2);
        n3=sz(3);
        D1dx = diff(speye(n1));
        D1dy = diff(speye(n2));
        D1dz = diff(speye(n3));
        
        D1 = [kron(speye(n3),kron(speye(n2),D1dx)); 
            kron(speye(n3),kron(D1dy,speye(n1)));
        kron(D1dz,kron(speye(n2),speye(n1)))];
    
        Delta = construct_O(D1,k);
        
    else
        printf(['Method: ', method, ' not supported.'])
    end
end