function x = grid_system_3d( b, k, rho)
% this function solves (L^k + rho*I ) x = b for L being the laplacian of a
% grid using DCT.

addpath mirt_dctn

[n1,n2,n3]=size(b);
% get eigenvalues
lambs1 = 4*sin(pi*((1:n1)-1)/(2*n1)).^2;
lambs2 = 4*sin(pi*((1:n2)-1)/(2*n2)).^2;
lambs3 = 4*sin(pi*((1:n3)-1)/(2*n3)).^2;

lambs = kron(kron(ones(1,n3),ones(1,n2)),lambs1)...
    + kron(kron(ones(1,n3),lambs2),ones(1,n1))...
    + kron(kron(lambs3,ones(1,n2)),ones(1,n1));

%kron(kron(lambs1,ones(1,n2)),ones(1,n3)) ...
%    + kron(kron(ones(1,n1),lambs2),ones(1,n3)) ...
%    + kron(kron(ones(1,n1),ones(1,n2)),lambs3);

lambs = reshape(lambs,[n1,n2,n3]);

%lambs = lambs1'*ones(1,n2) + ones(n1,1)*lambs2 + ones(n1,1)*lambs3
sigma = rho*lambs.^k + ones(n1,n2,n3);


tmp=mirt_dctn(b);
tmp=tmp.*(1./sigma);
x=mirt_idctn(tmp);

end
