function [edges1,edges2] = incidence2edgelist(D)
%INCIDENCE2EDGELIST vectorized computation from incidence matrix to
%edgelist
%   D is an m by n dimension sparse matrix with m edges and n nodes. 
%   each row of D has exactly 2 non-zeros.
%   The output is a matrix of size  m*2, describing the index of D.

% Edge weight is not considered in this function

[m,n]=size(D);
edgeslin = reshape(find(D'),[2,m])';
edges1lin = edgeslin(:,1);
edges2lin = edgeslin(:,2);
[edges1,col1]=ind2sub([n,m],edges1lin);
[edges2,col2]=ind2sub([n,m],edges2lin);


end

